Bug 25883

Summary: Highlight transfers on checkin screen table
Product: Koha Reporter: Andrew Fuerste-Henry <andrew>
Component: CirculationAssignee: Martin Renvoize <martin.renvoize>
Status: RESOLVED FIXED QA Contact: Testopia <testopia>
Severity: enhancement    
Priority: P5 - low CC: bdaeuber, gmcharlt, janet.mcgowan, kyle.m.hall, kyle, martin.renvoize, sally.healey
Version: masterKeywords: Manual
Hardware: All   
OS: All   
Change sponsored?: --- Patch complexity: Small patch
Text to go in the release notes:
This patch replaces the `Holding library` field in the check-in table with a new `Transfer to` field. The `Holding library` would always match the current branch, as holding branch is updated by the check-in process. We now highlight transfers by populating the new `Transfer to` field with the destination library.
Version(s) released in:
21.11.00
Bug Depends on: 23129    
Bug Blocks: 22160    
Attachments: Bug 25883: Replace 'homebranch' with 'transfer to' in returns
Bug 25883: Replace 'holdingbranch' with 'transfer to' in returns
Bug 25883: Replace 'holdingbranch' with 'transfer to' in returns
Bug 25883: (follow-up) Update columns_settings
Bug 25883: Replace 'holdingbranch' with 'transfer to' in returns
Bug 25883: (follow-up) Update columns_settings

Description Andrew Fuerste-Henry 2020-06-26 16:03:23 UTC
When an item generates an automatic transfer at checkin, there's nothing on the checkin screen to indicate that the transfer has generated. Following bug 23129, the holding branch shows the library where the item was checked in, rather than the library the item is going to. That's a good an accurate change, but means we don't have any way to see the transfer.
Comment 1 Martin Renvoize 2021-04-23 09:15:45 UTC
Sorry Andrew, I'm not sure I understand this bug.. could you clarify if for me.. I'm wondering if it's perhaps been resolved already in my other general work on transfers?
Comment 2 Martin Renvoize 2021-04-23 09:17:19 UTC
I thought you might mean something along the lines of 'Bug 26643 - Staff should be notified that a transfer has been completed on checkin'.. but I'm really not confident I understand well enough to mark it as a duplicate yet.
Comment 3 Benjamin Daeuber 2021-04-23 13:22:57 UTC
(In reply to Martin Renvoize from comment #2)
> I thought you might mean something along the lines of 'Bug 26643 - Staff
> should be notified that a transfer has been completed on checkin'.. but I'm
> really not confident I understand well enough to mark it as a duplicate yet.

The workflow issue this introduced was that staff often check-in items in batches, then sort them as a batch. Previously it was easy to see which items needed to go into a "transfer-to" pile, but changing the branch disrupted that workflow (since that column will now always say whatever brach the user is logged into).

I think there's a few ways to deal with this:

1. Add a class to the line in the table to indicate which branch the item is being transferred to. Libraries can then use custom CSS to color code them.

2. Add a column in the table indicating which branch the item is being transferred to.
Comment 4 Benjamin Daeuber 2021-04-23 13:37:32 UTC
(In reply to Benjamin Daeuber from comment #3)
> Previously it was easy to see which
> items needed to go into a "transfer-to" pile, but changing the branch
> disrupted that workflow 

That should say "changing the holding branch". It was nice to have a visual cue that an item needs to go to a certain place, just in case you missed something while checking in.
Comment 5 Martin Renvoize 2021-04-23 20:02:02 UTC
Thanks Benjamin, that's really helpful to understand. I'll have a look at coming up with a resolution wishlist I'm working in this area 🙂
Comment 6 Martin Renvoize 2021-04-27 13:12:08 UTC
Created attachment 120223 [details] [review]
Bug 25883: Replace 'homebranch' with 'transfer to' in returns

This patch replaces the "Holding library" column in the returns table
with a 'Transfer to' column that displays the destination for the item
awaiting transfer if a transfer exists.
Comment 7 Martin Renvoize 2021-04-27 13:13:16 UTC
OK, I've taken a punt at this one.. let me know if it is a reasonable route to the end goal and works for you.
Comment 8 Martin Renvoize 2021-05-07 09:57:41 UTC
Created attachment 120669 [details] [review]
Bug 25883: Replace 'holdingbranch' with 'transfer to' in returns

This patch replaces the "Holding library" column in the returns table
with a 'Transfer to' column that displays the destination for the item
awaiting transfer if a transfer exists.
Comment 9 Martin Renvoize 2021-10-14 09:27:34 UTC
Any feedback here?
Comment 10 Kyle M Hall 2021-10-14 13:38:38 UTC
Created attachment 126279 [details] [review]
Bug 25883: Replace 'holdingbranch' with 'transfer to' in returns

This patch replaces the "Holding library" column in the returns table
with a 'Transfer to' column that displays the destination for the item
awaiting transfer if a transfer exists.

Signed-off-by: Ben Daeuber <bdaeuber@fargolibrary.org>
Comment 11 Benjamin Daeuber 2021-10-14 13:42:39 UTC
Sorry about that. This looks good.

1. Set ShowAllCheckins to Show
2. Place a hold for an item to pickup at a different library.
3. Check in item and confirm transfer. After transfer is confirmed, the appropriate item appears in the Transfer To column.
4. After trapping and checking out hold, return item. The item's home library now appears in Transfer To column after confirming transfer.
5. Checking in item at home library, confirmed Transfer To column is blank (as expected, the item is not being transferred).
Comment 12 Katrin Fischer 2021-10-31 12:28:13 UTC
(In reply to Benjamin Daeuber from comment #11)
> Sorry about that. This looks good.
> 
> 1. Set ShowAllCheckins to Show
> 2. Place a hold for an item to pickup at a different library.
> 3. Check in item and confirm transfer. After transfer is confirmed, the
> appropriate item appears in the Transfer To column.
> 4. After trapping and checking out hold, return item. The item's home
> library now appears in Transfer To column after confirming transfer.
> 5. Checking in item at home library, confirmed Transfer To column is blank
> (as expected, the item is not being transferred).

Thx a lot for the test plan, Benjamin!
Comment 13 Katrin Fischer 2021-10-31 12:43:00 UTC
I have 2 issues with this change that I in fact like a lot!

1) The table configuration was not updated, so it still has "holdingbranch" for the returns table.

2) I wonder if replacing "holdingbranch" with "transfer to" works for all libraries and all use cases. If we think about rotating collections, floating collection, stock rotation and similar, seeing the holding library might still be useful. At the moment, the "transfer to" column will remain empty when there is no tranfer/hold, so this information is gone from display. Could we agree to add "transfer to" in addition to holdingbranch? With the table settings this would make it a flexible solution.
Comment 14 Martin Renvoize 2021-11-01 08:27:34 UTC
(In reply to Katrin Fischer from comment #13)
> I have 2 issues with this change that I in fact like a lot!
> 
> 1) The table configuration was not updated, so it still has "holdingbranch"
> for the returns table.

Ooops, I'll get right on to that.

> 2) I wonder if replacing "holdingbranch" with "transfer to" works for all
> libraries and all use cases. If we think about rotating collections,
> floating collection, stock rotation and similar, seeing the holding library
> might still be useful. At the moment, the "transfer to" column will remain
> empty when there is no tranfer/hold, so this information is gone from
> display. Could we agree to add "transfer to" in addition to holdingbranch?
> With the table settings this would make it a flexible solution.

Holding branch is always set to match the current branch at check-in so it will always display the branch you are checking in at.  I'm not sure how useful that information is and that's why I replaced it.
Comment 15 Martin Renvoize 2021-11-01 08:31:50 UTC
Created attachment 127148 [details] [review]
Bug 25883: (follow-up) Update columns_settings

Replace 'holdinglibrary' with 'transferlibrary' in checkedin
columns_settings description.
Comment 16 Katrin Fischer 2021-11-01 11:04:03 UTC
> > 2) I wonder if replacing "holdingbranch" with "transfer to" works for all
> > libraries and all use cases. If we think about rotating collections,
> > floating collection, stock rotation and similar, seeing the holding library
> > might still be useful. At the moment, the "transfer to" column will remain
> > empty when there is no tranfer/hold, so this information is gone from
> > display. Could we agree to add "transfer to" in addition to holdingbranch?
> > With the table settings this would make it a flexible solution.
> 
> Holding branch is always set to match the current branch at check-in so it
> will always display the branch you are checking in at.  I'm not sure how
> useful that information is and that's why I replaced it.

You are right, thx for the reply!
Comment 17 Katrin Fischer 2021-11-01 11:05:03 UTC
Created attachment 127155 [details] [review]
Bug 25883: Replace 'holdingbranch' with 'transfer to' in returns

This patch replaces the "Holding library" column in the returns table
with a 'Transfer to' column that displays the destination for the item
awaiting transfer if a transfer exists.

Signed-off-by: Ben Daeuber <bdaeuber@fargolibrary.org>

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 18 Katrin Fischer 2021-11-01 11:05:07 UTC
Created attachment 127156 [details] [review]
Bug 25883: (follow-up) Update columns_settings

Replace 'holdinglibrary' with 'transferlibrary' in checkedin
columns_settings description.

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 19 Jonathan Druart 2021-11-03 14:29:56 UTC
Pushed to master for 21.11, thanks to everybody involved!